org.apache.lucene.util.automaton

## Class RunAutomaton

- java.lang.Object
- - org.apache.lucene.util.automaton.RunAutomaton

- Direct Known Subclasses:
    ByteRunAutomaton, CharacterRunAutomaton

      public abstract class RunAutomaton
      extends Object

  Finite-state automaton with fast run operation.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RunAutomaton(Automaton a, int maxInterval, boolean tableize)` Constructs a new `RunAutomaton` from a deterministic `Automaton`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int[]` | `getCharIntervals()` Returns array of codepoint class interval start points.
    `int` | `getInitialState()` Returns initial state.
    `int` | `getSize()` Returns number of states in automaton.
    `boolean` | `isAccept(int state)` Returns acceptance status for given state.
    `int` | `step(int state, int c)` Returns the state obtained by reading the given char from the given state.
    `String` | `toString()` Returns a string representation of this automaton.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RunAutomaton

          public RunAutomaton(Automaton a,
                      int maxInterval,
                      boolean tableize)

      Constructs a new `RunAutomaton` from a deterministic `Automaton`.
      Parameters:
        `a` - an automaton

  - ### Method Detail

    - #### toString

          public String toString()

      Returns a string representation of this automaton.
      Overrides:
        `toString` in class `Object`

    - #### getSize

          public final int getSize()

      Returns number of states in automaton.

    - #### isAccept

          public final boolean isAccept(int state)

      Returns acceptance status for given state.

    - #### getInitialState

          public final int getInitialState()

      Returns initial state.

    - #### getCharIntervals

          public final int[] getCharIntervals()

      Returns array of codepoint class interval start points. The array should not be modified by the caller.

    - #### step

          public final int step(int state,
                 int c)

      Returns the state obtained by reading the given char from the given state. Returns -1 if not obtaining any such state. (If the original `Automaton` had no dead states, -1 is returned here if and only if a dead state is entered in an equivalent automaton with a total transition function.)

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.